#ifndef CHESSY_TRANSPOSITIONTABLE_H
#define CHESSY_TRANSPOSITIONTABLE_H
#include <array>
#include <cinttypes>

#include "ChessGame.h"

namespace chessy
{
    using HashValue = uint64_t;
    struct ZobristValues;
    class TranspositionTable;
}


struct chessy::ZobristValues
{
    std::array<HashValue, 64 * 12> pieces;
    std::array<HashValue, 16> castlingRights;
    std::array<HashValue, 8> enPassant;
    HashValue turn;

    HashValue getHash(const ChessGame&) const;

    inline HashValue getNumber(PieceType p, Index i) const
    {
        return pieces[static_cast<int>(p) * 64 + i];
    }

    void create(uint64_t seed);
};


class chessy::TranspositionTable
{

};

#endif //CHESSY_TRANSPOSITIONTABLE_H
